<template>
  <v-navigation-drawer
    :mini-variant.sync="mini"
    app
    permanent
    :clipped="true"
    width="210"
    color="gray"
  >
    <v-list dense>
      <v-list-item v-if="mini">
        <v-btn icon @click.stop="mini = !mini">
          <v-icon>mdi-chevron-double-right</v-icon>
        </v-btn></v-list-item
      >
      <v-list-item v-if="!mini">
        <v-spacer></v-spacer>
        <v-btn icon @click.stop="mini = !mini">
          <v-icon>mdi-chevron-double-left</v-icon>
        </v-btn></v-list-item
      >
      <v-list-group
        color="rgba(0, 0, 0, 0.87)"
        append-icon=""
        no-action
        :value="true"
      >
        <template v-slot:prependIcon>
          <v-icon color="rgba(0, 0, 0, 0.54)">mdi-hubspot</v-icon>
        </template>
        <template v-slot:activator>
          <v-list-item-title>Netobjects</v-list-item-title>
        </template>
        <v-list-item
          v-if="!$store.getters['user/isOrgaAdmin']"
          link
          @click="
            $route.path == '/claimresolution'
              ? ''
              : $router.push('/claimresolution')
          "
        >
          <v-list-item-title>Claim Resolution</v-list-item-title>
        </v-list-item>
        <v-list-item
          link
          @click="navigateNetobjects('asn');"
        >
          <v-list-item-title>Autonomous Systems</v-list-item-title>
        </v-list-item>
        <v-list-item
          link
          @click="navigateNetobjects('domain');"
        >
          <v-list-item-title>Domains</v-list-item-title>
        </v-list-item>
        <v-list-item
          link
          @click="navigateNetobjects('network');"
        >
          <v-list-item-title>Networks</v-list-item-title>
        </v-list-item>
        <v-list-item
          link
          @click="navigateNetobjects('ripehandle');"
        >
          <v-list-item-title>RIPE Handle</v-list-item-title>
        </v-list-item>
      </v-list-group>
      <v-list-item
        link
        @click="$route.path == '/mynode' ? '' : $router.push('/mynode')"
      >
        <v-list-item-icon>
          <v-icon>mdi-view-dashboard</v-icon>
        </v-list-item-icon>
        <v-list-item-title>My node</v-list-item-title>
      </v-list-item>
      <v-list-item
        link
        @click="
          $route.path == '/organisations' ? '' : $router.push('/organisations')
        "
      >
        <v-list-item-icon>
          <v-icon>mdi-family-tree</v-icon>
        </v-list-item-icon>
        <v-list-item-title>Organisations</v-list-item-title>
      </v-list-item>
      <v-divider></v-divider>
      <v-list-item
        link
        @click="$route.path == '/contacts' ? '' : $router.push('/contacts')"
      >
        <v-list-item-icon>
          <v-icon>mdi-contacts</v-icon>
        </v-list-item-icon>
        <v-list-item-title>Contacts</v-list-item-title>
      </v-list-item>
      <v-list-item
        link
        @click="
          $route.path == '/addcolleague' ? '' : $router.push('/addcolleague')
        "
      >
        <v-list-item-icon>
          <v-icon>mdi-account-plus</v-icon>
        </v-list-item-icon>
        <v-list-item-title>Add colleague</v-list-item-title>
      </v-list-item>
      <v-list-item
        link
        v-if="$store.getters['user/getNodes'].length > 1"
        @click="$store.commit('application/setShowSelectNodeDialog', true)"
      >
        <v-list-item-icon>
          <v-icon>mdi-account-switch</v-icon>
        </v-list-item-icon>
        <v-list-item-title>Switch Node</v-list-item-title>
      </v-list-item>
      <v-list-item
        link
        v-if="$store.getters['user/isPortalAdmin']"
        @click="$route.path == '/tags' ? '' : $router.push('/tags')"
      >
        <v-list-item-icon>
          <v-icon>mdi-tag</v-icon>
        </v-list-item-icon>
        <v-list-item-title>Tags</v-list-item-title>
      </v-list-item>
    </v-list>
    <div v-if="!mini" id="verInfo" class="px-1">
      <v-divider class="mb-1"></v-divider>
      <span class="text-caption font-weight-thin">
        This app runs
        <a href="https://gitlab.com/intevation/tuency/tuency">Tuency</a>, which
        is Free Software under AGPL-3.0-or-later.
        <br />
        <!-- The used symboles according to:
            https://en.wikipedia.org/wiki/Enclosed_Alphanumerics
         -->
        © nic.at &#x24D4; Intevation.
        <br />
        {{ versionNumber }}
      </span>
    </div>
  </v-navigation-drawer>
</template>
<style lang="scss" scoped>
#verInfo {
  position: absolute;
  bottom: 3px;
  width: 100%;
  font-size: 20%;
  line-height: 0.5rem;
  white-space: normal;
}
</style>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * Fadi Abbud <fadi.abbud@intevation.de>
 */
import { ref } from "vue";
import { useStore } from "@/store";
import router from "@/router";
import { useRoute } from "vue-router/composables";

const store = useStore();
const route = useRoute();
const versionNumber = ref(store.getters["application/appVersion"]);
const mini = ref(false);

/**
 * Navigates
 *
 * @param type
 */
const navigateNetobjects = (type) => {
  if (route.query.netobject_type != type) {
    const routerConfig = {
      path: '/netobjects',
      query: {
        netobject_type: type
      }
    }

    router.push(routerConfig);
  }
};
</script>
